// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f replicas.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use k8s_openapi::apimachinery::pkg::apis::meta::v1::Condition;
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// ReplicaSpec defines the desired state of the Longhorn replica
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "longhorn.io",
    version = "v1beta2",
    kind = "Replica",
    plural = "replicas"
)]
#[kube(namespaced)]
#[kube(status = "ReplicaStatus")]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct ReplicaSpec {
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub active: Option<bool>,
    /// Deprecated:Replaced by field `dataEngine`.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "backendStoreDriver"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub backend_store_driver: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "backingImage"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub backing_image: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "dataDirectoryName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub data_directory_name: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "dataEngine"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub data_engine: Option<ReplicaDataEngine>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "desireState"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub desire_state: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "diskID")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub disk_id: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "diskPath")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub disk_path: Option<String>,
    /// Deprecated: Replaced by field `image`.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "engineImage"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub engine_image: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "engineName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub engine_name: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "evictionRequested"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub eviction_requested: Option<bool>,
    /// FailedAt is set when a running replica fails or when a running engine is unable to use a replica for any reason.
    /// FailedAt indicates the time the failure occurred. When FailedAt is set, a replica is likely to have useful
    /// (though possibly stale) data. A replica with FailedAt set must be rebuilt from a non-failed replica (or it can
    /// be used in a salvage if all replicas are failed). FailedAt is cleared before a rebuild or salvage. FailedAt may
    /// be later than the corresponding entry in an engine's replicaTransitionTimeMap because it is set when the volume
    /// controller acknowledges the change.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "failedAt")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub failed_at: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "hardNodeAffinity"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub hard_node_affinity: Option<String>,
    /// HealthyAt is set the first time a replica becomes read/write in an engine after creation or rebuild. HealthyAt
    /// indicates the time the last successful rebuild occurred. When HealthyAt is set, a replica is likely to have
    /// useful (though possibly stale) data. HealthyAt is cleared before a rebuild. HealthyAt may be later than the
    /// corresponding entry in an engine's replicaTransitionTimeMap because it is set when the volume controller
    /// acknowledges the change.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "healthyAt")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub healthy_at: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub image: Option<String>,
    /// LastFailedAt is always set at the same time as FailedAt. Unlike FailedAt, LastFailedAt is never cleared.
    /// LastFailedAt is not a reliable indicator of the state of a replica's data. For example, a replica with
    /// LastFailedAt may already be healthy and in use again. However, because it is never cleared, it can be compared to
    /// LastHealthyAt to help prevent dangerous replica deletion in some corner cases. LastFailedAt may be later than the
    /// corresponding entry in an engine's replicaTransitionTimeMap because it is set when the volume controller
    /// acknowledges the change.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "lastFailedAt"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub last_failed_at: Option<String>,
    /// LastHealthyAt is set every time a replica becomes read/write in an engine. Unlike HealthyAt, LastHealthyAt is
    /// never cleared. LastHealthyAt is not a reliable indicator of the state of a replica's data. For example, a
    /// replica with LastHealthyAt set may be in the middle of a rebuild. However, because it is never cleared, it can be
    /// compared to LastFailedAt to help prevent dangerous replica deletion in some corner cases. LastHealthyAt may be
    /// later than the corresponding entry in an engine's replicaTransitionTimeMap because it is set when the volume
    /// controller acknowledges the change.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "lastHealthyAt"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub last_healthy_at: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "logRequested"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub log_requested: Option<bool>,
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "nodeID")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub node_id: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "rebuildRetryCount"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub rebuild_retry_count: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "revisionCounterDisabled"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub revision_counter_disabled: Option<bool>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "salvageRequested"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub salvage_requested: Option<bool>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "snapshotMaxCount"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub snapshot_max_count: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "snapshotMaxSize"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub snapshot_max_size: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "unmapMarkDiskChainRemovedEnabled"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub unmap_mark_disk_chain_removed_enabled: Option<bool>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_name: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeSize"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_size: Option<String>,
}

/// ReplicaSpec defines the desired state of the Longhorn replica
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum ReplicaDataEngine {
    #[serde(rename = "v1")]
    V1,
    #[serde(rename = "v2")]
    V2,
}

/// ReplicaStatus defines the observed state of the Longhorn replica
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct ReplicaStatus {
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub conditions: Option<Vec<Condition>>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "currentImage"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub current_image: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "currentState"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub current_state: Option<String>,
    /// Deprecated: Replaced by field `spec.evictionRequested`.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "evictionRequested"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub eviction_requested: Option<bool>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "instanceManagerName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub instance_manager_name: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ip: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "logFetched"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub log_fetched: Option<bool>,
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "ownerID")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub owner_id: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub port: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "salvageExecuted"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub salvage_executed: Option<bool>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub started: Option<bool>,
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "storageIP")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub storage_ip: Option<String>,
}
